<script class='controller'>
    setTimeout(function() {

        /*           ACTUALIZAR CONTADORES               */
        $(document).off('click', "#updateCharts");
        $(document).on('click', '#updateCharts', function(e) {
            var userIntel = JSON.parse(window.localStorage.getItem("userIntel")),
                panelToShow = userIntel.panelUsuario,
                userId = $('#sidebarLoaded').attr('userIdPanel');
            $("#loading").fadeIn("fast", function() {
                showPanel(panelToShow, userId);
            });
        });

        /** CUANDO INICIA EL MODULO CARGAMOS LAS PRIMERAS TARJETAS */
        $('.anim1').velocity("transition.slideUpBigIn", {
            stagger: 100,
            complete: function() {
                $('#buscarDevolpt').focus();
            }
        });

        /** BUSCAMOS LA ORDEN DE DEVOLUCION POR EL BOTON O POR LA PISTOLA */
        $(document).off('click', ".buscarDevolBoxpt button");
        $(document).on('click', '.buscarDevolBoxpt button', function(e) {

            var devolVal = $(document).find('#buscarDevolpt').val();
            if (devolVal == '') {
                $.growl.error({
                    message: "Debe ingresar el codigo de la Orden"
                });
                return;
            }
            getThisTraslado();
        });
		
        $(document).find('#buscarDevolpt').keypress(function(e) {
            if (e.which == 13) {

                var devolVal = $(document).find('#buscarDevolpt').val();
                if (devolVal == '') {
                    $.growl.error({
                        message: "Debe ingresar el codigo de la Orden"
                    });
                    return;
                }
                getThisTraslado();
            }
        });

        /** LE RESTAMOS 1 UNIDAD AL LISTADO SELECCIONADO */

        /** LE RESTAMOS 1 UNIDAD AL LISTADO SELECCIONADO */
        $(document).off('click', ".restarUnidad");
        $(document).on('click', '.restarUnidad', function(e) {

            var codigoBarrasDevuelto = $(this).parent().parent().parent().find('.codigoBarrasDevuelto').html(),
                unidTotales = $(this).parent().parent().parent().find('.unidTotales').html(),
                isListed = 0,
                unidXDevolver = $(this).parent().parent().parent().find('.unidXDevolver').html();

            var totalEscan = $('.unidadesEscaenadasTotalpt span').html();
            totalEscan = +totalEscan - 1;
			
            $('.unidadesEscaenadasTotalpt span').html(totalEscan);

            $(document).find('.listadoDevolpt tbody tr').each(function(i, n) {
                var codbarras = $(n).find('.codigoBarras').html(),
                    numlin = $(n).find('.numlin').html(),
                    supedido = $(n).find('.supedido').html(),
                    unidadesLeidas = $(n).find('.unidadesLeidas').html(),
                    unidades = $(n).find('.unidades').html();

                if (codbarras == codigoBarrasDevuelto && isListed == 0) {
                    isListed = 1
                    restantes = unidadesLeidas - 1;
                    $(n).find('.unidadesLeidas').html(restantes.toFixed(0));
                    $(n).removeClass('fullyReadPicki');
                    $(n).slideDown('slow');
                    $(n).find('.card').removeClass('bg-info text-white');
                }

            });

            unidXDevolver--;
			
            if (unidXDevolver == 0) {
                $(this).parent().parent().parent().parent().remove();

                var cajasLeidas = cajasRead();
                $('.unidadesEscaenadasTotalCajapt span').html(cajasLeidas.length);

                return;
            }
            var newPropor = (+unidXDevolver * 100) / +unidTotales
            $(this).parent().parent().parent().find('.unidXDevolver').html(unidXDevolver);
			$(this).parent().parent().parent().find('.thisCantAcum').html(unidXDevolver);
            $(this).parent().parent().parent().find('.unidXDevolverPropor').attr('style', 'width: ' + newPropor.toFixed(0) + '%');
        });

        /** ELIMINAMOS EL LISTADO SELECCIONADO */
        $(document).off('click', ".eliminarUnidades");
        $(document).on('click', '.eliminarUnidades', function(e) {
		
            var codigoBarrasDevuelto = $(this).parent().parent().parent().find('.codigoBarrasDevuelto').html(),
                unidTotales = $(this).parent().parent().parent().find('.unidTotales').html(),
                isListed = 0,
                unidXDevolver = $(this).parent().parent().parent().find('.unidXDevolver').html();

            var totalEscan = $('.unidadesEscaenadasTotalpt span').html();
            totalEscan = +totalEscan - +unidXDevolver;
            $('.unidadesEscaenadasTotalpt span').html(totalEscan);

            $(this).parent().parent().parent().parent().remove();

            var cajasLeidas = cajasRead();
            $('.unidadesEscaenadasTotalCajapt span').html(cajasLeidas.length);

            $(document).find('.listadoDevolpt tbody tr').each(function(i, n) {
                var codbarras = $(n).find('.codigoBarras').html(),
                    numlin = $(n).find('.numlin').html(),
                    supedido = $(n).find('.supedido').html(),
                    unidadesLeidas = $(n).find('.unidadesLeidas').html(),
                    unidades = $(n).find('.unidades').html();

                if (codbarras == codigoBarrasDevuelto && isListed == 0) {
                    isListed = 1;
                    $(n).find('.unidadesLeidas').html('0');
                    $(n).removeClass('fullyReadPicki');
                    $(n).slideDown('slow');
                }

            });
            return;
        });

        /** GUARDAMOS LA  DEVOLUCION */
        $(document).off('click', "#saveNewDevolpt");
        $(document).on('click', '#saveNewDevolpt', function(e) {
			//alert("Accion iniciada");
            var rowsCount = 0,
                devoldetail = [],
                userId = $('#sidebarLoaded').attr('userIdPanel'),
                carritonBox = $('#carritonBoxpt').val();

            if (carritonBox == '') {
                $.growl.error({
                    message: "Debe ingresar el número de carrito"
                });
                return;
            }
			//alert(Date.now());
			//alert("IDCarrito recuperado: " + carritonBox );
			//var idtransaccion = carritonBox + userId   ;
			var idtransaccion = (Date.now());
			//alert("idTrasancion Original: " + idtransaccion );
            //idtransaccion = Math.abs(idtransaccion.hashCode());
			//alert("idTrasancion Cod: " + idtransaccion );
			
			//alert("IdTransaccion preparado");
			
            $(document).find('.porDevolInfoBox').each(function(i, n) {
                $(n).find('.thisReadDevol tbody tr').each(function(ii, nn) {

                    var devolRow = {};
                    devolRow.codarticulo = $(nn).find('.codarticuloRead').html();
                    devolRow.talla = $(nn).find('.tallaRead').html();
                    devolRow.color = $(nn).find('.colorRead').html();
                    devolRow.oldquantity = $(nn).find('.oldquantityRead').html();
                    devolRow.type = '22';
                    devolRow.barcode = $(nn).find('.barcodeRead').html();
                    devolRow.returnquantity = $(nn).find('.thisCantAcum').html();
                    devolRow.cajamas = $(nn).find('.cajMasRead').html();
                    devolRow.ubi = $(nn).find('.locatRead').html();;
                    devolRow.doc = $(nn).find('.docRead').html();
                    devolRow.usuario = userId;
                    devolRow.carrito = carritonBox;
					devolRow.idtransaccion = idtransaccion;
                    devolRow.idlinea = rowsCount;

                    devoldetail.push(devolRow);

                    rowsCount++;
                });
            });
			//alert("Documento preparado, Lineas: "+rowsCount);
			//alert(JSON.stringify(devoldetail));
			
            if (rowsCount > 0) {
              
                $(this).velocity("transition.slideUpOut", {
                    duration: 200,
                    complete: function() {
                        $('#saveNewDevolFakept').velocity("transition.slideUpIn", {
                            duration: 200,
                            complete: function() {
                                var formData = new FormData(),
                                    userId = $('#sidebarLoaded').attr('userIdPanel');
                                formData.append('userDevol', userId);
                                formData.append('devol', JSON.stringify(devoldetail));
                                formData.append('meth', 'saveNewTraslado');
                                apiCall(formData, function(data) {
									//alert("Metodos invocados");
									//alert(JSON.stringify(data));
                                    console.log(data);
                                    if (data.status == "saved") {
                                        $('.anim3,.porDevolInfoBox,#saveNewDevolFakept').velocity("transition.slideUpOut", {
                                            duration: 200,
                                            complete: function() {
                                                swal({
                                                    title: "Felicitaciones",
                                                    text: "Su Traslado ha sido registrado en el sistema exitosamente.",
                                                    type: "success",
                                                    showCancelButton: false,
                                                    confirmButtonText: 'Entendido',
                                                    cancelButtonText: 'salir'
                                                });
                                                $('.porDevolInfoBox').remove();
                                                $('.anim11,#saveNewDevolpt').velocity("transition.slideUpIn", {
                                                    duration: 200
                                                })
                                            }
                                        });
                                    } else {
                                        $('#saveNewDevolFakept').velocity("transition.slideUpOut", {
                                            duration: 200,
                                            complete: function() {
                                                swal({
                                                    title: "Lo Sentimos",
                                                    text: "Hubo un problema para guardar sus datos, intente de nuevo",
                                                    type: "error",
                                                    showCancelButton: false,
                                                    confirmButtonText: 'Entendido',
                                                    cancelButtonText: 'salir'
                                                });
                                                $('#saveNewDevolpt').velocity("transition.slideUpIn", {
                                                    duration: 200
                                                })
                                            }
                                        });
                                    }
                                });

                            }
                        });
                    }
                });
            } else {
                $.growl.error({
                    message: "No hay productos leidos para recibir"
                });
            }

        });

        /** OMSTRAMOS LAS UBICACIOEN SDEL PRODUCTO */
        $(document).off('click', ".thisDevolProd");
        $(document).on('click', '.thisDevolProd', function(e) {
			
            $('.refreshPageIcon').addClass('fa-spin');
            var formData = new FormData(),
                codBar = $(this).find('.codigoBarras').html(),
                codArt = $(this).find('.codArticulo').html(),
                talla = $(this).find('.talla').html(),
                suPedido = $(this).find('.suPedido').html(),
                color = $(this).find('.color').html();

            formData.append('codArt', codArt);
            formData.append('talla', talla);
            formData.append('color', color);
            formData.append('suPedido', suPedido);
            formData.append('meth', 'consultarUbics');
            apiCall(formData, function(data) {
				
                console.log(data);
                if (data.rows.length > 0) {
                    $('.boxProductInfoViewpt').slideUp(800, function() {
                        var oldCod = $('.viewThisProdNumbrpt').html();
                        if (oldCod == codBar) {
                            $('.refreshPageIcon').removeClass('fa-spin');
                            return;
                        }
                        $('.viewThisProdNumbrpt').html(codBar);
                        $('.listadoUbicspt tbody').html('');
                        $(data.rows).each(function(i, n) {
                            $('.listadoUbicspt tbody').append(' <tr class="thisUBicProd">' +
                                '<td class="CajaMast" data-valtype="CajaMast">' + n[0] + '</td>' +
                                '<td class="Ubic" data-valtype="Ubic">' + n[1] + '</td> ' +
								'<td class="Stock" data-valtype="Stock">' + n[2] + '</td> ' +
                                ' </tr>');
                        });
                        $('.boxProductInfoViewpt').slideDown(200, function() {
                            $('.refreshPageIcon').removeClass('fa-spin');
                        });
                    });
                } else {
                    $.growl.error({
                        message: "Este producto no devolvio ubicaciones registradas"
                    });
                    return;
                }
            });
        });

        enterSubm();
		
    }, 1000);

    /** OBTENEMOS LOS DATOS DE LA ORDEN DE TRASLADO */
    function getThisTraslado() {
        $('.searchingBtnpt').html('<i class="fa fa-spinner fa-spin"></i>');
        var trasladoVal = $(document).find('#buscarDevolpt').val(),
            formData = new FormData(),
            userId = $('#sidebarLoaded').attr('userIdPanel');
        formData.append('userId', userId);
        formData.append('trasladoVal', trasladoVal);
        formData.append('meth', 'consultarTraslado');
        apiCall(formData, function(data) {
            console.log(data);
            $('.searchingBtnpt').html('<i class="fa fa-search"></i>');
            var resp = data.rows;
            //console.log(resp);
            console.log(resp.length);
            if (resp.length > 0) {
                $('.anim3').velocity("transition.slideUpBigOut", {
                    duration: 0,
                    complete: function() {
                        var code = '';
                        $('.listadoDevolpt tbody').html(code);
                        $('.ordenTitleNumbrpt').html(trasladoVal);
                        //console.log(resp[0][40]);
                        var sortedlist = resp.sort(function(a,b){ return a['ORDENADOFILAS'] > b['ORDENADOFILAS'] ? 1 : -1; });
                        for (i = 0; i < sortedlist.length; i++) {
                            $('.listadoDevolpt tbody').append(' <tr class="thisDevolProd">' +
                                '<td class="codigo_fabricante" data-valtype="codigo_fabricante">' + sortedlist[i]['CODIGO_FABRICANTE'] + '</td> ' +
								'<td class="codigoBarras" data-valtype="codigoBarras">' + sortedlist[i]['CODBARRAS'] + '</td> ' +
                                '<td class="offscreen ordenadofilas" data-valtype="ordenadofilas">' + sortedlist[i]['ORDENADOFILAS'] + '</td> ' +
                                '<td class="descricion" data-valtype="descricion">' + sortedlist[i]['TODORECIBIDO'] + '</td> ' +
                                '<td class="referencia" data-valtype="referencia">' + sortedlist[i]['REFERENCIA'] + '</td> ' +
                                '<td class="unidadesTotales" data-valtype="unidadesTotales">' + sortedlist[i]['UNIDADESTOTAL'] + '</td> ' +
                                '<td class="unidadesLeidas" data-valtype="unidadesLeidas">0</td> ' +
								'<td class="fabricante" data-valtype="fabricante">' + sortedlist[i]['FABRICANTE'] + '</td> ' +
								'<td class="codArticulo" data-valtype="codArticulo">' + sortedlist[i]['CODARTICULO'] + '</td>' +
                                '<td class="offscreen talla" data-valtype="talla">' + sortedlist[i]['TALLA'] + '</td> ' +
                                '<td class="offscreen color" data-valtype="color">' + sortedlist[i]['COLOR'] + '</td> ' +
                                '<td class="offscreen suPedido" data-valtype="suPedido">' + sortedlist[i]['SUPEDIDO'] + '</td> ' +
								'<td class="codigoBarras2" data-valtype="codigoBarras2">' + sortedlist[i]['CODBARRAS2'] + '</td> ' +
								'<td class="cBar3" data-valtype="cBar3">' + sortedlist[i]['CODBARRAS3'] + '</td> ' +
                                ' </tr>');
                        }
                        $('.anim11').velocity("transition.slideUpBigOut", {
                            stagger: 0,
                            complete: function() {
                                $('.anim3').velocity("transition.slideUpBigIn", {
                                    stagger: 150,
                                    complete: function() {
                                        $('#cajamasterBoxpt').focus();
                                    }
                                });
                            }
                        });
                    }
                });
            } else {
                $.growl.error({
                    message: "No existen documentos por procesar"
                });
                return;
            }
        });
    }

    /** AL LEER CON PISTOLA UN CODIGO DE BARRA */
    function getThisProd(total) {
		
        var codbar = $(document).find('#productoBoxpt').val(),
            locatRead = $(document).find('#locationBoxpt').val(),
            cajMasRead = $(document).find('#cajamasterBoxpt').val(),
            isInvoked = 0,
            isListed = 0,
            isPresent = 0;
			
        $(document).find('.listadoDevolpt tbody tr').not('.fullyReadPicki').each(function(i, n) {
            var codigoBarras = $(n).find('.codigoBarras').html(),
			    codigoBarras2 = $(n).find('.codigoBarras2').html(),
                cBar3 = $(n).find('.cBar3').html(),
                codarticuloRead = $(n).find('.codArticulo').html(),
                tallaRead = $(n).find('.talla').html(),
                colorRead = $(n).find('.color').html(),
                docRead = $(n).find('.suPedido').html(),
                leidasUnidades = $(n).find('.unidadesLeidas').html(),
                totalUnidades = $(n).find('.unidadesTotales').html();

            // if ((codigoBarras == codbar) || (codigoBarras2 == codbar) || (cBar3 == codbar) )  {
			if (codigoBarras == codbar || codigoBarras2 == codbar || cBar3 == codbar){
                var qyt = 1;
                isPresent = 1;
				$(document).find('#productoBoxpt').val('');
                $(document).find('#productoBoxpt').focus();
                
                var formData = new FormData();
                formData.append('codigoArticulo', codarticuloRead);
                formData.append('talla', tallaRead);
                formData.append('color', colorRead);
                formData.append('codigoBarrasCaja', cajMasRead);
                formData.append('meth', 'totalProdsInBox');
				
                apiCall(formData, function(data) {
                    var resp = JSON.parse(data.result.GetQuantityProductInMasterBoxResult);
                    if (resp.code == '200') {
                        /* if (resp.quantity <= (+totalUnidades - +leidasUnidades)) {
                            qyt = resp.quantity;
                        } */
                    }
					//alert("Total comparar: "+total);
					
					//alert(JSON.stringify(resp));
					
                    $(document).find('.porDevolInfoBox').not('.cajaMasterCard').each(function(ii, nn) {
                        var codigoBarrasDevuelto = $(nn).find('.codigoBarrasDevuelto').html();
                        if (codigoBarras == codigoBarrasDevuelto || codigoBarras2 == codigoBarrasDevuelto ) {
							
                            isInvoked = 1;
                            var unidXDevolver = $(nn).find('.unidXDevolver').html();
                            var unidTotales = $(nn).find('.unidTotales').html();
							
                            if (+unidXDevolver < +unidTotales) {
                                                              
                                $(nn).find('.thisReadDevol tbody tr').each(function(iii, nnn) {
                                    var thisLocation = $(nnn).find('.locatRead').html(),
                                        thisCajaMas = $(nnn).find('.cajMasRead').html(),
                                        thisCant = $(nnn).find('.thisCantAcum').html();
										
                                    if(total != 'N/A'){
										
										if (thisLocation == locatRead && thisCajaMas == cajMasRead && total > thisCant) {
											isListed = 1;
											thisCant++;
											//alert("CANTIDAD PITADA DEL CODBARRAS: "+thisCant);
											$(nnn).find('.thisCantAcum').html(thisCant);
											
											var totalEscan = $('.unidadesEscaenadasTotalpt span').html();
											totalEscan++;
											$('.unidadesEscaenadasTotalpt span').html(totalEscan);
											
											unidXDevolver = +unidXDevolver + +qyt;
											leidasUnidades = +leidasUnidades + +qyt;
											var newPropor = (+unidXDevolver * 100) / +unidTotales
											$(nn).find('.unidXDevolver').html(unidXDevolver);
											$(n).find('.unidadesLeidas').html(leidasUnidades);
											$(nn).find('.unidXDevolverPropor').attr('style', 'width: ' + newPropor.toFixed(0) + '%');
											if (+unidXDevolver == +unidTotales) {
												$(nn).find('.card.cod_'+codigoBarrasDevuelto).addClass('bg-info text-white');
												$(n).addClass('fullyReadPicki');
												$(n).slideUp('slow');
											}
								
										}else if (thisLocation == locatRead && thisCajaMas == cajMasRead && total <= thisCant){
											
											isListed = 1;
											$.growl.error({
												message: "Sin mas Stock en esa UBICACION"
											});
										}	
									}else{
										
										if (thisLocation == locatRead && thisCajaMas == cajMasRead) {
											isListed = 1;
											thisCant++;
											$(nnn).find('.thisCantAcum').html(thisCant);
											
											var totalEscan = $('.unidadesEscaenadasTotalpt span').html();
											totalEscan++;
											$('.unidadesEscaenadasTotalpt span').html(totalEscan);
											
											unidXDevolver = +unidXDevolver + +qyt;
											leidasUnidades = +leidasUnidades + +qyt;
											var newPropor = (+unidXDevolver * 100) / +unidTotales
											$(nn).find('.unidXDevolver').html(unidXDevolver);
											$(n).find('.unidadesLeidas').html(leidasUnidades);
											$(nn).find('.unidXDevolverPropor').attr('style', 'width: ' + newPropor.toFixed(0) + '%');
										}
									}
                                });
                                if (isListed == 0) {
                                    var listThis = `
                                            <tr>
                                                <td class="text-dark locatRead text-center">` + locatRead + `</td>
                                                <td class="text-dark cajMasRead text-center">` + cajMasRead + `</td>
                                                <td class="text-dark thisCantAcum text-center">` + qyt + `</td>
                                                <td class="offscreen codarticuloRead text-center">` + codarticuloRead + `</td>
                                                <td class="offscreen tallaRead text-center">` + tallaRead + `</td>
                                                <td class="offscreen colorRead text-center">` + colorRead + `</td>
                                                <td class="offscreen oldquantityRead text-center">` + unidTotales + `</td>
                                                <td class="offscreen barcodeRead text-center">` + codigoBarras + `</td>
                                                <td class="offscreen docRead text-center">` + docRead + `</td>
                                            </tr>
                                            `;
                                    $(nn).find('.thisReadDevol tbody').append(listThis);
									
									var totalEscan = $('.unidadesEscaenadasTotalpt span').html();
									totalEscan++;
									$('.unidadesEscaenadasTotalpt span').html(totalEscan);
									unidXDevolver = +unidXDevolver + +qyt;
									leidasUnidades = +leidasUnidades + +qyt;
									var newPropor = (+unidXDevolver * 100) / +unidTotales
									$(nn).find('.unidXDevolver').html(unidXDevolver);
									$(n).find('.unidadesLeidas').html(leidasUnidades);
									$(nn).find('.unidXDevolverPropor').attr('style', 'width: ' + newPropor.toFixed(0) + '%');
									if (+unidXDevolver == +unidTotales) {
										$(nn).find('.card.cod_'+codigoBarras).addClass('bg-info text-white');
										$(n).addClass('fullyReadPicki');
										$(n).slideUp('slow');
									}
                                }

                            } else {
                                $.growl.error({
                                    message: "No puedes exceder el límite de la Orden"
                                });
                            }
                        }
                    });
                    if (isInvoked == 0) {

                        var fullCard = '';
                        totalUnidades = +totalUnidades - +leidasUnidades;
                        if (totalUnidades == qyt) {
                            fullCard = 'bg-info text-white';
                            $(n).addClass('fullyReadPicki');
                            $(n).slideUp('slow');
                        }
                        var newPropor = (+qyt * 100) / +totalUnidades
                        var invoke = `
                        <div class="col-sm-12 col-lg-12 col-xl-6 porDevolInfoBox">
                            <div class="card anim cod_` + codigoBarras + `  ` + fullCard + `">
                                <div class="card-header">
                                    <div class="card-title"><i class="fa fa-barcode "></i> <strong class=" codigoBarrasDevuelto">` + codbar + `</strong></div>
                                    <div class="card-options ">
                                        <span class="btn btn-info mr30 float-left restarUnidad"><i class="fa fa-minus"></i> </span>
                                        <span class="btn btn-join text-white float-left pull-left mr10 eliminarUnidades"><i class="fa fa-times  "></i> </span>
                                    </div>
                                </div>
                                <div class="table-responsive">
                                    <table class="table table-bordered border-top card-table table-vcenter text-nowrap table-primary thisReadDevol">
                                        <thead class="bg-info text-white text-center">
                                            <tr>
                                                <th class="text-white">Ubicacion</th>
                                                <th class="text-white">Caja Master</th>
                                                <th class="text-white">Cantidad</th>
                                                <th class="offscreen">codarticulo</th>
                                                <th class="offscreen">talla</th>
                                                <th class="offscreen">color</th>
                                                <th class="offscreen">oldquantity</th>
                                                <th class="offscreen">barcode</th>
                                                <th class="offscreen">doc</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            <tr>
                                                <td class="text-dark locatRead text-center">` + locatRead + `</td>
                                                <td class="text-dark cajMasRead text-center">` + cajMasRead + `</td>
                                                <td class="text-dark thisCantAcum ` + cajMasRead + ` ` + codbar + ` ` + locatRead + ` text-center">` + qyt + `</td>
                                                <td class="offscreen codarticuloRead text-center">` + codarticuloRead + `</td>
                                                <td class="offscreen tallaRead text-center">` + tallaRead + `</td>
                                                <td class="offscreen colorRead text-center">` + colorRead + `</td>
                                                <td class="offscreen oldquantityRead text-center">` + totalUnidades + `</td>
                                                <td class="offscreen barcodeRead text-center">` + codigoBarras + `</td>
                                                <td class="offscreen docRead text-center">` + docRead + `</td>
                                            </tr>
                                        </tbody>
                                    </table>
                                    <div class="offscreen "></div>
                                </div>
                                <div class="card-body">
                                    <div class="row">
                                        <div class="col text-center">
                                            <label class="tx-12">Unidades Totales</label>
                                            <h2 class="font-weight-normal unidTotales">` + totalUnidades + `</h2>
                                        </div>
                                        <div class="col border-left text-center">
                                            <label class="tx-12">A Trasladar</label>
                                            <h2 class="font-weight-normal unidXDevolver">` + qyt + `</h2>
                                        </div>
                                    </div>
                                    <div class="progress mt-4">
                                        <div class="progress-bar progress-bar-striped progress-bar-animated bg-join unidXDevolverPropor" style="width: ` + newPropor + `%"></div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        `;

                        var totalEscan = $('.unidadesEscaenadasTotalpt span').html();
                        totalEscan++;
                        $('.unidadesEscaenadasTotalpt span').html(totalEscan);
                        qyt = +leidasUnidades + +qyt;
                        $(n).find('.unidadesLeidas').html(qyt);
                        $(invoke).insertAfter('.readerPistolBoxpt');
                        $('.cod_' + codigoBarras).velocity("transition.slideUpBigIn", {
                            stagger: 250
                        });
                    }
                });
            }else{
				isPresent = 3;
			}

        });
		if(isPresent == 3){
			$.growl.warning({
				message: codbar+ " ya no se encuentra en la orden"
			});
		}
        if (isPresent == 5) {
            var docRead = 0;
            $(document).find('.listadoDevolpt tbody tr').not('.fullyReadPicki').each(function(i, n) {
                docRead = $(n).find('.suPedido').html();
            });
            $(document).find('.porDevolInfoBox').not('.cajaMasterCard').each(function(ii, nn) {
                var codigoBarrasDevuelto = $(nn).find('.codigoBarrasDevuelto').html();
                if (codbar == codigoBarrasDevuelto) {
                    isInvoked = 1;
                    var unidXDevolver = $(nn).find('.unidXDevolver').html();
                    unidXDevolver++;
                    var newPropor = 100;
                    $(nn).find('.unidXDevolver').html(unidXDevolver);
                    //$(nn).find('.unidTotales').html(unidXDevolver);
                    $(nn).find('.unidXDevolverPropor').attr('style', 'width: ' + newPropor.toFixed(0) + '%');
                    var talla = 0,
                        color = 0;
                    $(nn).find('.thisReadDevol tbody tr').each(function(iii, nnn) {
                        var thisLocation = $(nnn).find('.locatRead').html(),
                            thisCajaMas = $(nnn).find('.cajMasRead').html(),
                            thisCant = $(nnn).find('.thisCantAcum').html();
                        talla = $(nnn).find('.tallaRead').html();
                        color = $(nnn).find('.colorRead').html();
						if(total != 'N/A'){
							if (thisLocation == locatRead && thisCajaMas == cajMasRead && total > thisCant) {
								isListed = 1;
								thisCant++;
								$(nnn).find('.thisCantAcum').html(thisCant);
							}else{
								isListed = 1;
								$.growl.warning({
									message: "Sin mas Stock en esa ubicacion",
									duration: 8000
								});
								
							}
						}else{
							
							if (thisLocation == locatRead && thisCajaMas == cajMasRead) {
								isListed = 1;
								thisCant++;
								$(nnn).find('.thisCantAcum').html(thisCant);
							}else{
								isListed = 1;
								$.growl.warning({
									message: "Sin mas Stock en esa ubicacion",
									duration: 8000
								});
								
							}
						}
                        
                    });
                    if (isListed == 0) {

                        var listThis = `
                                            <tr>
                                                <td class="offscreen text-dark locatRead text-center">` + locatRead + `</td>
                                                <td class="text-dark cajMasRead text-center">` + cajMasRead + `</td>
                                                <td class="text-dark thisCantAcum text-center">1</td>
                                                <td class="offscreen codarticuloRead text-center">0</td>
                                                <td class="offscreen tallaRead text-center">` + talla + `</td>
                                                <td class="offscreen colorRead text-center">` + color + `</td>
                                                <td class="offscreen oldquantityRead text-center">0</td>
                                                <td class="offscreen barcodeRead text-center">` + codbar + `</td>
                                                <td class="offscreen docRead text-center">` + docRead + `</td>
                                            </tr>
                                            `;
                        $(nn).find('.thisReadDevol tbody').append(listThis);
                    }
                    var totalEscan = $('.unidadesEscaenadasTotalpt span').html();
                    totalEscan++;
                    $('.unidadesEscaenadasTotalpt span').html(totalEscan);
                }
            });
            if (isInvoked == 0) {
                var talla = 0,
                    color = 0,
                    codArt = 0,
                    formData = new FormData();
                formData.append('codbar', codbar);
                formData.append('meth', 'consultarPNL');
                apiCall(formData, function(data) {
                    if (data.status == "gotProd") {

                        $.growl.warning({
                            message: "Este producto no se encuentra en la Orden de Recepcion escaneada, será agregado en la lista como producto adicional ",
                            duration: 8000
                        });

                        if (data.rows.length > 0) {
                            talla = data.rows[0]['TALLA'];
                            color = data.rows[0]['COLOR'];
                            codArt = data.rows[0]['CODARTICULO'];
                        } else {
                            if (data.rows2.length > 0) {
                                talla = data.rows2[0]['TALLA'];
                                color = data.rows2[0]['COLOR'];
                                codArt = data.rows2[0]['CODARTICULO'];
                            } else {
                                if (data.rows3.length > 0) {
                                    talla = data.rows3[0]['TALLA'];
                                    color = data.rows3[0]['COLOR'];
                                    codArt = data.rows3[0]['CODARTICULO'];
                                }
                            }
                        }

                        var newPropor = 100;
                        var invoke = `
                        <div class="col-sm-12 col-lg-12 col-xl-6 porDevolInfoBox productoAdicional">
                            <div class="card anim cod_` + codbar + ` bg-warning text-white">
                                <div class="card-header">
                                    <div class="card-title"><i class="fa fa-barcode "></i> <strong class=" codigoBarrasDevuelto">` + codbar + `</strong></div>
                                    <div class="card-options ">
                                         <span class="btn btn-info mr30 float-left restarUnidad"><i class="fa fa-minus"></i> </span> 
                                        <span class="btn btn-join text-white float-left pull-left mr10 eliminarUnidades"><i class="fa fa-times  "></i> </span>
                                    </div>
                                </div>
                                <div class="table-responsive">
                                    <table class="table table-bordered border-top card-table table-vcenter text-nowrap table-primary thisReadDevol">
                                        <thead class="bg-info text-white text-center">
                                            <tr>
                                                <th class="text-white offscreen">Ubicacion</th>
                                                <th class="text-white">Caja Master</th>
                                                <th class="text-white">Cantidad</th>
                                                <th class="offscreen">codarticulo</th>
                                                <th class="offscreen">talla</th>
                                                <th class="offscreen">color</th>
                                                <th class="offscreen">oldquantity</th>
                                                <th class="offscreen">barcode</th>
                                                <th class="offscreen">doc</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            <tr>
                                                <td class="offscreen text-dark locatRead text-center">` + locatRead + `</td>
                                                <td class="text-dark cajMasRead text-center">` + cajMasRead + `</td>
                                                <td class="text-dark thisCantAcum text-center">1</td>
                                                <td class="offscreen codarticuloRead text-center">` + codArt + `</td>
                                                <td class="offscreen tallaRead text-center">` + talla + `</td>
                                                <td class="offscreen colorRead text-center">` + color + `</td>
                                                <td class="offscreen oldquantityRead text-center">0</td>
                                                <td class="offscreen barcodeRead text-center">` + codbar + `</td>
                                                <td class="offscreen docRead text-center">` + docRead + `</td>
                                            </tr>
                                        </tbody>
                                    </table>
                                    <div class="offscreen "></div>
                                </div>
                                <div class="card-body">
                                    <div class="row">
                                        <div class="col text-center">
                                            <label class="tx-12">Unidades Totales</label>
                                            <h2 class="font-weight-normal unidTotales">1</h2>
                                        </div>
                                        <div class="col border-left text-center">
                                            <label class="tx-12">Por Recibir</label>
                                            <h2 class="font-weight-normal unidXDevolver">1</h2>
                                        </div>
                                    </div>
                                    <div class="progress mt-4">
                                        <div class="progress-bar progress-bar-striped progress-bar-animated bg-join unidXDevolverPropor" style="width: ` + newPropor + `%"></div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        `;


                        var totalEscan = $('.unidadesEscaenadasTotalpt span').html();
                        totalEscan++;
                        $('.unidadesEscaenadasTotalpt span').html(totalEscan);

                        $(invoke).insertAfter('.readerPistolBoxpt');
                        $('.cod_' + codbar).velocity("transition.slideUpBigIn", {
                            stagger: 250
                        });
                    } else {
                        $.growl.error({
                            message: "Codigo de barras no existe en el sistema ",
                            duration: 6000
                        });
                    }
                });
            }

        }
        $(document).find('#productoBoxpt').val('');
        $(document).find('#productoBoxpt').focus();

    }

    /** FUNCIONALIDAD DE LOS INPUT */
    function enterSubm() {
        $('.cajamasterBoxInppt').keypress(function(e) {
            if (e.which == 13) {
                $('.productoBoxInppt').val('');
                $('.productoBoxInppt').focus();
            }
        });
        $('.productoBoxInppt').keypress(function(e) {
            if (e.which == 13) {
                 var prodVal = $(document).find('#productoBoxpt').val(),
					cajaVal = $(document).find('#cajamasterBoxpt').val(),
					locatVal = $(document).find('#locationBoxpt').val(),
					tipoReg = $(document).find("input[type=radio][name=caja-radiospt]:checked").val();
					
				if(tipoReg == 'U'){
					
					if (prodVal == '' || locatVal == '') {
						$.growl.error({
							message: "Debe llenar todos los campos"
						});
						return;
					}else{
						var formData = new FormData;
						formData.append('CodProd', prodVal);
						formData.append('UbicCod', locatVal);
						formData.append('CodCajaM', '0000');
						formData.append('meth', 'consultarUbiXCod');
						apiCall(formData, function(data) {
						 // alert(JSON.stringify(data));
							if (data.status == "ERROR") {
								$.growl.error({
									message: "ERROR al validar ubicaciòn y CodBarras",
									duration: 6000
								});
								$(document).find('#locationBoxpt').val('');
								$(document).find('#locationBoxpt').focus();
								
							}else if(data.status == "T"){
								
								//alert(data.stock);
								//alert(JSON.stringify(data));
								getThisProd(data.stock);
								
							}else {

								$.growl.error({
									message: data.msg,
									duration: 6000
								});
								
								$(document).find('#locationBoxpt').focus();
							}
						});
					}
				}else if(tipoReg == 'C'){
					
					getThisProd('N/A');
					
				}
            }
        });

        $(document).find('#locationBoxpt').val('0000');
        $(document).off('change', "input[type=radio][name=caja-radiospt]");
        $(document).on('change', "input[type=radio][name=caja-radiospt]", function(e) {
            //console.log(this.value);
            if (this.value == 'U') {
                $(document).find('#locationBoxpt').val('');
                $(document).find('.cajamasterBoxInpGpt').hide();
                $(document).find('.locationBoxInpGpt').show();
                $(document).find('#cajamasterBoxpt').val('0000');
                $('.locationBoxInppt').focus();
            } else if (this.value == 'C') {
                $(document).find('#cajamasterBoxpt').val('');
                $(document).find('.cajamasterBoxInpGpt').show();
                $(document).find('.locationBoxInpGpt').hide();
                $(document).find('#locationBoxpt').val('0000');
                $('.cajamasterBoxInppt').focus();
            }
        });

        /** AL PRESIONAR EL BOTON EL CODIGO DE BARRA Y LO CARGAMOS AL LISTADO */
        $(document).off('click', ".readerPistolBoxpt button.envipt");
        $(document).on('click', '.readerPistolBoxpt button.envipt', function(e) {
			//alert("Click en boton");
			
            var prodVal = $(document).find('#productoBoxpt').val(),
                cajaVal = $(document).find('#cajamasterBoxpt').val(),
				locatVal = $(document).find('#locationBoxpt').val(),
				tipoReg = $(document).find("input[type=radio][name=caja-radiospt]:checked").val();
			
			//alert("Tipo Ubivcacion: "+tipoReg);
			
			if(tipoReg == 'U'){
				//alert("Tipo Ubivcacion");
				if (prodVal == '' || locatVal == '') {
					$.growl.error({
						message: "Debe llenar todos los campos"
					});
					return;
				}else{
					
					var formData = new FormData;
					formData.append('CodProd', prodVal);
					formData.append('UbicCod', locatVal);
					formData.append('CodCajaM', '0000');
					formData.append('meth', 'consultarUbiXCod');
					apiCall(formData, function(data) {
						
					 // alert(JSON.stringify(data));
					 
						if (data.status == "ERROR") {
							$.growl.error({
								message: "ERROR al validar ubicaciòn y CodBarras",
								duration: 6000
							});
							$(document).find('#locationBoxpt').val('');
							$(document).find('#locationBoxpt').focus();
							
						}else if(data.status == "T"){
							
							//alert("STOCK EN UBICACION: "+data.stock);
							//alert(JSON.stringify(data));
							getThisProd(data.stock);
							
						}else {

							$.growl.error({
								message: data.msg,
								duration: 6000
							});
							
							$(document).find('#locationBoxpt').focus();
						}
					});
				}
			}else if(tipoReg == 'C'){
				
				getThisProd('N/A');
				
			}
				
           
        });

        /*           ACTUALIZAR CAJA O INDIVIDUAL               */
        $(document).off('click', ".leerCajaCompletapt");
        $(document).on('click', '.leerCajaCompletapt', function(e) {
            $('.readerPistolBoxpt').velocity("transition.slideLeftBigOut", {
                duration: 200,
                complete: function() {
                    $('.readerPistolUnitBoxpt').velocity("transition.slideLeftBigIn", {
                        duration: 200
                    });
                }
            });
        });
        $(document).off('click', ".leerProductosIndividualespt");
        $(document).on('click', '.leerProductosIndividualespt', function(e) {
            $('.readerPistolUnitBoxpt').velocity("transition.slideLeftBigOut", {
                duration: 200,
                complete: function() {
                    $('.readerPistolBoxpt').velocity("transition.slideLeftBigIn", {
                        duration: 200
                    });
                }
            });
        });

        $(document).off('click', ".readerPistolUnitBoxpt button.enviUnitpt");
        $(document).on('click', '.readerPistolUnitBoxpt button.enviUnitpt', function(e) {

            var cajaVal = $(document).find('#productoBoxUnitpt').val();
            if (cajaVal == '') {
                $.growl.error({
                    message: "Debe llenar todos los campos"
                });
                return;
            }
            getThisCaja();
        });
        $('.productoBoxUnitInppt').keypress(function(e) {
            if (e.which == 13) {
				
                var cajaVal = $(document).find('#productoBoxUnitpt').val();
                if (cajaVal == '') {
                    $.growl.error({
                        message: "Debe llenar todos los campos"
                    });
                    return;
                }
				
                getThisCaja();
            }
        });
		$('.locationBoxpt').keypress(function(e) {
			
            if (e.which == 13) {
				
                var cajaVal = $(document).find('#locationBoxpt').val();
                if (cajaVal == '') {
                    $.growl.error({
                        message: "Debe llenar todos los campos"
                    });
                    return;
                }else{
					$(document).find('#productoBoxpt').focus();
				}
            }
        });
    }

    /** OBTENEMOS LOS DATOS DE LA CAJA MASTER Y TODOS SUS PRODUCTOS */
    function getThisCaja() {
        $('.refreshPageIcon').addClass('fa-spin');
        var suPedido = $(document).find('.thisDevolProd .suPedido').html();
        var cajaVal = $(document).find('#productoBoxUnitpt').val(),
            formData = new FormData();

        var cajasLeidas = cajasRead();
        if (cajasLeidas.includes(cajaVal)) {
            $.growl.error({
                message: "Esta caja ya fue capturada, no puede repetir la caja en el mismo pedido"
            });
            $(document).find('#productoBoxUnitpt').val('');
            $(document).find('#productoBoxUnitpt').focus();
            return;
        }

        formData.append('suPedido', suPedido);
        formData.append('cajaVal', cajaVal);
        formData.append('meth', 'consultarCajaMaster');
        apiCall(formData, function(data) {
            console.log(data);
            $('.refreshPageIcon').removeClass('fa-spin');
            if (data.rows.length > 0) {
                $(data.rows).each(function(i, n) {
                    var suPedido = 0,
                        isRead = 0;
                    $(document).find('.listadoDevolpt tbody tr').not('.fullyReadPicki').each(function(ii, nn) {
                        var codigoBarras = $(nn).find('.codigoBarras').html(),
							codigoBarras2 = $(nn).find('.codigoBarras2').html(),
                            codarticuloRead = $(nn).find('.codArticulo').html(),
                            tallaRead = $(nn).find('.talla').html(),
                            colorRead = $(nn).find('.color').html(),
                            leidasUnidades = $(nn).find('.unidadesLeidas').html(),
                            totalUnidades = $(nn).find('.unidadesTotales').html();

                        suPedido = $(nn).find('.suPedido').html();

                        if (n[4] == codigoBarras && isRead == 0) {
                            isRead = 1;
                            var totalLeidas = +leidasUnidades + +n[5];
                            $(nn).find('.unidadesLeidas').html(totalLeidas);
                            if (totalLeidas == totalUnidades) {
                                $(nn).addClass('fullyReadPicki');
                                $(nn).slideUp('slow');
                            }
                        } else {
                            console.log(n[4]);
                            console.log(codigoBarras);
                        }
                    });

                    var newPropor = 100;
                    var invoke = `
                        <div class="col-sm-12 col-lg-12 col-xl-6 porDevolInfoBox cajaMasterCard" data-codcaja="` + cajaVal + `">
                            <div class="card anim cod_` + n[4] + ` bg-info text-white">
                                <div class="card-header">
                                    <div class="card-title"><i class="fa fa-barcode "></i> <strong class=" codigoBarrasDevuelto">` + n[4] + `</strong></div>
                                    <div class="card-options ">
                                        <span class="btn btn-info mr30 float-left restarUnidad"><i class="fa fa-minus"></i> </span>
                                        <span class="btn btn-info text-white float-left pull-left mr10 "><i class="fa fa-copyright  "></i> </span>
                                        <span class="btn btn-join text-white float-left pull-left mr10 eliminarUnidades"><i class="fa fa-times  "></i> </span>
                                    </div>
                                </div>
                                <div class="table-responsive">
                                    <table class="table table-bordered border-top card-table table-vcenter text-nowrap table-primary thisReadDevol">
                                        <thead class="bg-info text-white text-center">
                                            <tr>
                                                <th class="text-white">Ubicacion</th>
                                                <th class="text-white">Caja Master</th>
                                                <th class="text-white">Cantidad</th>
                                                <th class="offscreen">codarticulo</th>
                                                <th class="offscreen">talla</th>
                                                <th class="offscreen">color</th>
                                                <th class="offscreen">oldquantity</th>
                                                <th class="offscreen">barcode</th>
                                                <th class="offscreen">doc</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            <tr>
                                                <td class="text-dark locatRead text-center">0000</td>
                                                <td class="text-dark cajMasRead text-center">` + n[0] + `</td>
                                                <td class="text-dark thisCantAcum text-center">` + n[5] + `</td>
                                                <td class="offscreen codarticuloRead text-center">` + n[1] + `</td>
                                                <td class="offscreen tallaRead text-center">` + n[2] + `</td>
                                                <td class="offscreen colorRead text-center">` + n[3] + `</td>
                                                <td class="offscreen oldquantityRead text-center">` + n[5] + `</td>
                                                <td class="offscreen barcodeRead text-center">` + n[4] + `</td>
                                                <td class="offscreen docRead text-center">` + suPedido + `</td>
                                            </tr>
                                        </tbody>
                                    </table>
                                    <div class="offscreen "></div>
                                </div>
                                <div class="card-body">
                                    <div class="row">
                                        <div class="col text-center">
                                            <label class="tx-12">Unidades Totales</label>
                                            <h2 class="font-weight-normal unidTotales">` + n[5] + `</h2>
                                        </div>
                                        <div class="col border-left text-center">
                                            <label class="tx-12">A Trasladar</label>
                                            <h2 class="font-weight-normal unidXDevolver">` + n[5] + `</h2>
                                        </div>
                                    </div>
                                    <div class="progress mt-4">
                                        <div class="progress-bar progress-bar-striped progress-bar-animated bg-join unidXDevolverPropor" style="width: ` + newPropor + `%"></div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        `;

                    var totalEscan = $('.unidadesEscaenadasTotalpt span').html();
                    totalEscan = +totalEscan + +n[5];
                    $('.unidadesEscaenadasTotalpt span').html(totalEscan);

                    $(invoke).insertAfter('.readerPistolUnitBoxpt');
                    $('.cod_' + n[4]).velocity("transition.slideUpBigIn", {
                        stagger: 250
                    });
                });


                var cajasLeidas = cajasRead();
                $('.unidadesEscaenadasTotalCajapt span').html(cajasLeidas.length);

                $(document).find('#productoBoxUnitpt').val('');
                $(document).find('#productoBoxUnitpt').focus();

            } else {
                $.growl.error({
                    message: "Esta caja no contiene productos registrados"
                });
                return;
            }
        });
    }

    /* LEEMOS LAS CAJAS QUE HAN SIDO PITADAS */
    function cajasRead() {
        var cajasLeidas = [];
        $(document).find('.porDevolInfoBox').each(function(ii, nn) {
            var codCaja = $(nn).attr('data-codcaja');
            if (!cajasLeidas.includes(codCaja)) {
                cajasLeidas.push(codCaja);
            }
        });
        return cajasLeidas;
    }
</script>